Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class KeyStoreSpi

    java.lang.Object
      |
      +--java.security.KeyStoreSpi

public abstract class KeyStoreSpi
extends Object

This class defines the Service Provider Interface (SPI) for the `KeyStore` class. All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a keystore for a particular keystore type.

Since:
  1.2
See Also:
  `KeyStore`

Constructor Summary
`KeyStoreSpi()`

Method Summary
`abstract Enumeration` | `engineAliases()` Lists all the alias names of this keystore.
`abstract boolean` | `engineContainsAlias(String alias)` Checks if the given alias exists in this keystore.
`abstract void` | `engineDeleteEntry(String alias)` Deletes the entry identified by the given alias from this keystore.
`abstract Certificate` | `engineGetCertificate(String alias)` Returns the certificate associated with the given alias.
`abstract String` | `engineGetCertificateAlias(Certificate cert)` Returns the (alias) name of the first keystore entry whose certificate matches the given certificate.
`abstract Certificate[]` | `engineGetCertificateChain(String alias)` Returns the certificate chain associated with the given alias.
`abstract Date` | `engineGetCreationDate(String alias)` Returns the creation date of the entry identified by the given alias.
`abstract Key` | `engineGetKey(String alias, char[] password)` Returns the key associated with the given alias, using the given password to recover it.
`abstract boolean` | `engineIsCertificateEntry(String alias)` Returns true if the entry identified by the given alias is a trusted certificate entry, and false otherwise.
`abstract boolean` | `engineIsKeyEntry(String alias)` Returns true if the entry identified by the given alias is a key entry, and false otherwise.
`abstract void` | `engineLoad(InputStream stream, char[] password)` Loads the keystore from the given input stream.
`abstract void` | `engineSetCertificateEntry(String alias, Certificate cert)` Assigns the given certificate to the given alias.
`abstract void` | `engineSetKeyEntry(String alias, byte[] key, Certificate[] chain)` Assigns the given key (that has already been protected) to the given alias.
`abstract void` | `engineSetKeyEntry(String alias, Key key, char[] password, Certificate[] chain)` Assigns the given key to the given alias, protecting it with the given password.
`abstract int` | `engineSize()` Retrieves the number of entries in this keystore.
`abstract void` | `engineStore(OutputStream stream, char[] password)` Stores this keystore to the given output stream, and protects its integrity with the given password.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyStoreSpi

    public KeyStoreSpi()

Method Detail

### engineGetKey

    public abstract Key engineGetKey(String alias,
                                     char[] password)
                              throws NoSuchAlgorithmException,
                                     UnrecoverableKeyException

  Returns the key associated with the given alias, using the given password to recover it.
  Parameters:
    `alias` - the alias name
    `password` - the password for recovering the key
  Returns:
    the requested key, or null if the given alias does not exist or does not identify a key entry.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm for recovering the key cannot be found
    `UnrecoverableKeyException` - if the key cannot be recovered (e.g., the given password is wrong).

### engineGetCertificateChain

    public abstract Certificate[] engineGetCertificateChain(String alias)

  Returns the certificate chain associated with the given alias.
  Parameters:
    `alias` - the alias name
  Returns:
    the certificate chain (ordered with the user's certificate first and the root certificate authority last), or null if the given alias does not exist or does not contain a certificate chain (i.e., the given alias identifies either a trusted certificate entry or a key entry without a certificate chain).

### engineGetCertificate

    public abstract Certificate engineGetCertificate(String alias)

  Returns the certificate associated with the given alias.

  If the given alias name identifies a trusted certificate entry, the certificate associated with that entry is returned. If the given alias name identifies a key entry, the first element of the certificate chain of that entry is returned, or null if that entry does not have a certificate chain.

  Parameters:
    `alias` - the alias name
  Returns:
    the certificate, or null if the given alias does not exist or does not contain a certificate.

### engineGetCreationDate

    public abstract Date engineGetCreationDate(String alias)

  Returns the creation date of the entry identified by the given alias.
  Parameters:
    `alias` - the alias name
  Returns:
    the creation date of this entry, or null if the given alias does not exist

### engineSetKeyEntry

    public abstract void engineSetKeyEntry(String alias,
                                           Key key,
                                           char[] password,
                                           Certificate[] chain)
                                    throws KeyStoreException

  Assigns the given key to the given alias, protecting it with the given password.

  If the given key is of type `java.security.PrivateKey`, it must be accompanied by a certificate chain certifying the corresponding public key.

  If the given alias already exists, the keystore information associated with it is overridden by the given key (and possibly certificate chain).

  Parameters:
    `alias` - the alias name
    `key` - the key to be associated with the alias
    `password` - the password to protect the key
    `chain` - the certificate chain for the corresponding public key (only required if the given key is of type `java.security.PrivateKey`).
  Throws:
    `KeyStoreException` - if the given key cannot be protected, or this operation fails for some other reason

### engineSetKeyEntry

    public abstract void engineSetKeyEntry(String alias,
                                           byte[] key,
                                           Certificate[] chain)
                                    throws KeyStoreException

  Assigns the given key (that has already been protected) to the given alias.

  If the protected key is of type `java.security.PrivateKey`, it must be accompanied by a certificate chain certifying the corresponding public key.

  If the given alias already exists, the keystore information associated with it is overridden by the given key (and possibly certificate chain).

  Parameters:
    `alias` - the alias name
    `key` - the key (in protected format) to be associated with the alias
    `chain` - the certificate chain for the corresponding public key (only useful if the protected key is of type `java.security.PrivateKey`).
  Throws:
    `KeyStoreException` - if this operation fails.

### engineSetCertificateEntry

    public abstract void engineSetCertificateEntry(String alias,
                                                   Certificate cert)
                                            throws KeyStoreException

  Assigns the given certificate to the given alias.

  If the given alias already exists in this keystore and identifies a trusted certificate entry, the certificate associated with it is overridden by the given certificate.

  Parameters:
    `alias` - the alias name
    `cert` - the certificate
  Throws:
    `KeyStoreException` - if the given alias already exists and does not identify a trusted certificate entry, or this operation fails for some other reason.

### engineDeleteEntry

    public abstract void engineDeleteEntry(String alias)
                                    throws KeyStoreException

  Deletes the entry identified by the given alias from this keystore.
  Parameters:
    `alias` - the alias name
  Throws:
    `KeyStoreException` - if the entry cannot be removed.

### engineAliases

    public abstract Enumeration engineAliases()

  Lists all the alias names of this keystore.
  Returns:
    enumeration of the alias names

### engineContainsAlias

    public abstract boolean engineContainsAlias(String alias)

  Checks if the given alias exists in this keystore.
  Parameters:
    `alias` - the alias name
  Returns:
    true if the alias exists, false otherwise

### engineSize

    public abstract int engineSize()

  Retrieves the number of entries in this keystore.
  Returns:
    the number of entries in this keystore

### engineIsKeyEntry

    public abstract boolean engineIsKeyEntry(String alias)

  Returns true if the entry identified by the given alias is a key entry, and false otherwise.
  Parameters:
    `alias` - the alias for the keystore entry to be checked
  Returns:
    true if the entry identified by the given alias is a key entry, false otherwise.

### engineIsCertificateEntry

    public abstract boolean engineIsCertificateEntry(String alias)

  Returns true if the entry identified by the given alias is a trusted certificate entry, and false otherwise.
  Parameters:
    `alias` - the alias for the keystore entry to be checked
  Returns:
    true if the entry identified by the given alias is a trusted certificate entry, false otherwise.

### engineGetCertificateAlias

    public abstract String engineGetCertificateAlias(Certificate cert)

  Returns the (alias) name of the first keystore entry whose certificate matches the given certificate.

  This method attempts to match the given certificate with each keystore entry. If the entry being considered is a trusted certificate entry, the given certificate is compared to that entry's certificate. If the entry being considered is a key entry, the given certificate is compared to the first element of that entry's certificate chain (if a chain exists).

  Parameters:
    `cert` - the certificate to match with.
  Returns:
    the (alias) name of the first entry with matching certificate, or null if no such entry exists in this keystore.

### engineStore

    public abstract void engineStore(OutputStream stream,
                                     char[] password)
                              throws IOException,
                                     NoSuchAlgorithmException,
                                     CertificateException

  Stores this keystore to the given output stream, and protects its integrity with the given password.
  Parameters:
    `stream` - the output stream to which this keystore is written.
    `password` - the password to generate the keystore integrity check
  Throws:
    `IOException` - if there was an I/O problem with data
    `NoSuchAlgorithmException` - if the appropriate data integrity algorithm could not be found
    `CertificateException` - if any of the certificates included in the keystore data could not be stored

### engineLoad

    public abstract void engineLoad(InputStream stream,
                                    char[] password)
                             throws IOException,
                                    NoSuchAlgorithmException,
                                    CertificateException

  Loads the keystore from the given input stream.

  If a password is given, it is used to check the integrity of the keystore data. Otherwise, the integrity of the keystore is not checked.

  Parameters:
    `stream` - the input stream from which the keystore is loaded
    `password` - the (optional) password used to check the integrity of the keystore.
  Throws:
    `IOException` - if there is an I/O or format problem with the keystore data
    `NoSuchAlgorithmException` - if the algorithm used to check the integrity of the keystore cannot be found
    `CertificateException` - if any of the certificates in the keystore could not be loaded

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >